#if !defined(AFX_DROPSOURCE_H__20000910_0CED_34E8_7F81_0080AD509054__INCLUDED_)
#define AFX_DROPSOURCE_H__20000910_0CED_34E8_7F81_0080AD509054__INCLUDED_

#pragma once


class CDropSource : 
   public CComObjectRootEx<CComMultiThreadModelNoCS>, 
   public IDropSource
{
public:

BEGIN_COM_MAP(CDropSource)
   COM_INTERFACE_ENTRY(IDropSource)
END_COM_MAP()

   STDMETHOD(QueryContinueDrag)( 
         BOOL fEscapePressed,
         DWORD grfKeyState)
   {
      if( fEscapePressed ) return ResultFromScode(DRAGDROP_S_CANCEL);
      if( (grfKeyState & MK_LBUTTON)==0 ) return ResultFromScode(DRAGDROP_S_DROP);
      return NOERROR;
   }

   STDMETHOD(GiveFeedback)(DWORD /*dwEffect*/)
   {
      return ResultFromScode(DRAGDROP_S_USEDEFAULTCURSORS);
   }
   
};


#endif // !defined(AFX_DROPSOURCE_H__20000910_0CED_34E8_7F81_0080AD509054__INCLUDED_)
